{ ******************************************************************
  Fast Fourier Transform (modified from Pascal program by Don Cross)
  ******************************************************************
  This program compares the FFT with the direct computation of the
  frequencies, on a set of random data.

  Results are stored in the output file freq.txt
  ****************************************************************** }

program freq;

uses
  utypes, ufft;

const
  NumSamples = 512;             { Buffer size (power of 2) }
  MaxIndex   = NumSamples - 1;  { Max. array index }

var
  InArray, OutArray : array[0..MaxIndex] of Complex;
  OutFile           : Text;
  I                 : Integer;
  Z                 : Complex;

begin
  { Fill input buffers with random data }
  for I := 0 to MaxIndex do
    InArray[I] := Cmplx(Random(10000), Random(10000));

  Assign(OutFile, 'freq.txt');
  Rewrite(OutFile);

  WriteLn(OutFile);
  WriteLn(OutFile, '*** Testing procedure CalcFrequency ***');
  WriteLn(OutFile);

  FFT(InArray, OutArray);

  for I := 0 to MaxIndex do
    begin
      CalcFrequency(I, InArray, Z);
      WriteLn(OutFile, I:4,
              Re(OutArray[I]):15:6, Re(Z):15:6,
              Im(OutArray[I]):20:6, Im(Z):15:6);
    end;

  Close(OutFile);
end.

