{ ******************************************************************
  This program computes the determinant and inverse of a square
  matrix.

  The file matrix1.inc is an example data file with N = 4
  ****************************************************************** }

program detinv;

uses
  utypes, ugausjor, ustrings, matutils;

{$i matrix1.inc}

var
  D1, D2 : Float;  { Determinants }

begin
  SetFormat(12, 6, False, True);
  WriteMatrix('Original matrix', A);

  GaussJordan(A, D1);

  case MathErr of
    MatOk : begin
              Writeln('Determinant = ', FloatStr(D1));
              Writeln;
              WriteMatrix('Inverse matrix', A);

              { Reinvert matrix. D2 = 1/D1 }
              GaussJordan(A, D2);

              if MathErr = MatOk then
                begin
                  Writeln('Determinant = ', FloatStr(D2));
                  Writeln;
                  WriteMatrix('Reinverted inverse matrix', A);
                  WriteLn('Product of determinants = ', FloatStr(D1 * D2));
                end;
            end;
    MatSing : Write('Singular matrix!');
    MatErrDim : Write('Non-compatible dimensions!');
  end;
end.

