{ ******************************************************************
  This program solves a system of linear equations (A * X = B) with
  a single constant vector by the Gauss-Jordan method.

  The file matrix3.inc is an example data file with N = 4
  ****************************************************************** }

program lineq1;

uses
  utypes, ulineq, ustrings, matutils;

{$i matrix3.inc}

var
  D : Float;  { Determinant }

begin
  SetFormat(12, 6, False, True);
  WriteMatrix('System matrix', A);
  WriteVector('Constant vector', B);

  { Solve system }
  LinEq(A, B, D);

  { Write results }
  case MathErr of
    MatOk   : begin
                WriteMatrix('Inverse matrix', A);
                WriteVector('Solution vector', B);
                WriteLn('Determinant = ', FloatStr(D));
              end;
    MatSing : WriteLn('Singular matrix!');
  end;
end.
