{ ******************************************************************
  This program solves a system of N linear equations (A * X = B)
  with P constant vectors by the Gauss-Jordan method.

  The file matrix2.inc is an example data file with N = 4 and P = 5
  ****************************************************************** }

program lineqm;

uses
  utypes, ugausjor, ustrings, matutils;

{$i matrix2.inc}

var
  D : Float;  { Determinant }

begin
  SetFormat(12, 6, False, True);
  WriteMatrixCols('System matrix', A, 1, N);
  WriteMatrixCols('Constant vectors', A, N + 1, M);

  { Solve system }
  GaussJordan(A, D);

  { Write results }
  case MathErr of
    MatOk     : begin
                  WriteMatrixCols('Inverse matrix', A, 1, N);
                  WriteMatrixCols('Solution vectors', A, N + 1, M);
                  WriteLn('Determinant = ', FloatStr(D));
                end;
    MatSing   : WriteLn('Singular matrix!');
    MatErrDim : WriteLn('Non-compatible dimensions!');
  end;
end.
