{ ******************************************************************
  This program solves a system of linear equations (A * X = B) with
  a single constant vector by the LU decomposition method.

  The file matrix3.inc is an example data file with N = 4
  ****************************************************************** }

program test_lu;

uses
  utypes, ulu, ustrings, matutils;

{$i matrix3.inc}

var
  X : array[1..N] of Float;  { Solution vector }

begin
  SetFormat(12, 6, False, True);
  WriteMatrix('System matrix', A);
  WriteVector('Constant vector', B);

  { Perform LU decomposition of A. If successful, solve system }

  LU_Decomp(A);

  if MathErr = MatSing then
    begin
      WriteLn('Singular matrix!');
      Halt;
    end;

  LU_Solve(A, B, X);

  WriteVector('Solution vector', X);
end.
