{ ******************************************************************
  This program generates a binary file of random numbers,
  to be used with Marsaglia's DIEHARD battery of tests
  (http://stat.fsu.edu/pub/diehard/)
  ****************************************************************** }

program randfile;

uses
  urandom;

const
  N = 3000000;  { Generate N numbers }

var
  I, R : LongInt;
  F    : file of LongInt;

begin
  { Initialize the "Mersenne Twister" generator
    with the built-in generator }

  Randomize;

  InitMT(Trunc(Random * 2147483647));

  { Create file }

  Assign(F, 'random.dat');
  Rewrite(F);

  for I := 1 to N do
    begin
      R := IRanGen;
      Write(F, R);
    end;

  Close(F);
end.
