{ ******************************************************************
  Khi-2 and Woolf's tests
  ****************************************************************** }

program khi2;

uses
  utypes, ukhi2, uinvgam;

const
  Alpha = 0.05;  { Significance level }

var
  K2, K2c, G : Float;
  DoF        : Integer;

{ ------------------------------------------------------------------
  Data for the conformity test
  ------------------------------------------------------------------ }

const
  N = 4;

var
  Obs  : array[1..N] of Integer = (104, 76, 18, 2);
  Calc : array[1..N] of Float   = ( 94, 86, 14, 6);

{ ------------------------------------------------------------------
  Data for the independence test
  ------------------------------------------------------------------ }

const
  Nr = 2; Nc = 3;  { Number of rows and columns }

var
  T : array[1..Nr, 1..Nc] of Integer =  { Contingency table }
  ((280, 210, 110),
   (220,  90,  90));

{ ------------------------------------------------------------------
  Main program
  ------------------------------------------------------------------ }

begin
  { Tests for conformity }

  Khi2_Conform(Obs, Calc, 0, K2, DoF);
  Woolf_Conform(Obs, Calc, 0, G, DoF);

  K2c := InvKhi2(DoF, 1.0 - Alpha);

  WriteLn('Comparison of two distributions:');

  WriteLn;

  WriteLn('Pearson''s Khi-2            = ', K2:10:4, '  (', DoF, ' DoF)');
  WriteLn('Woolf''s G                  = ', G:10:4, '  (', DoF, ' DoF)');
  WriteLn('Critical value (p = ', Alpha:5:3, ') = ', K2c:10:4);

  WriteLn;
  WriteLn;

 { Tests for independence }

  Khi2_Indep(T, K2, DoF);
  Woolf_Indep(T, G, DoF);

  K2c := InvKhi2(DoF, 1.0 - Alpha);

  WriteLn('Analysis of contingency table:');
  WriteLn;

  WriteLn('Pearson''s Khi-2            = ', K2:10:4, '  (', DoF, ' DoF)');
  WriteLn('Woolf''s G                  = ', G:10:4, '  (', DoF, ' DoF)');
  WriteLn('Critical value (p = ', Alpha:5:3, ') = ', K2c:10:4);
end.
