{ ******************************************************************
  Eigenvalues of a general square matrix
  ****************************************************************** }

unit ueigval;

interface

uses
  utypes, ubalance, uelmhes, uhqr;

{$define Matrix array[Lb1..Ub1 : Integer; Lb2..Ub2 : Integer] of Float}

{$define CompVector array[LbC..UbC : Integer] of Complex}

procedure EigenVals(var A : Matrix; var Lambda : CompVector);

implementation

procedure EigenVals(var A : Matrix; var Lambda : CompVector);
var
  I_low,
  I_igh : Integer;
  Scale : array[Lb1..Ub1] of Float;
  I_int : array[Lb1..Ub1] of Integer;

begin
  if (LbC <> Lb1) or (LbC <> Lb2) or
     (UbC <> Ub1) or (UbC <> Ub2) then
       begin
         SetErrCode(MatErrDim);
         Exit;
       end;

  Balance(A, I_low, I_igh, Scale);
  ElmHes(A, I_low, I_igh, I_int);
  Hqr(A, I_low, I_igh, Lambda);
end;

end.
